local AddonName = "FuryDestroyer"
local version = GetAddOnMetadata(AddonName, "Version")
local TITLE = "|cFF00FF00"..AddonName.."|r"
local TTitle = "|cFF00FF00"..AddonName.." |cFF80CCE5V: |r"..version
local addon = LibStub("AceAddon-3.0"):NewAddon(AddonName, "AceConsole-3.0", "AceEvent-3.0")
local media = LibStub:GetLibrary("LibSharedMedia-3.0")

addon.Name = AddonName
FuryDestroyer = addon

local BuffName
local BuffTex
local FDID = 109949 --FuryDestroyer ID
local target

local defaults = {
	profile = {
		SoundFile = "Fanfare1"
	},
	global = {

	}
}

function addon:Options()
	local options = {
		name = AddonName.." "..GetAddOnMetadata(AddonName,"Version"),
	    handler = addon,
	    type = 'group',
	    args = {
			selectSound = {
				name = SOUND_LABEL,
				type = 'select',
				dialogControl = "LSM30_Sound",
				get = function() return self.db.profile.SoundFile end,
				set = function(info, value) self.db.profile.SoundFile = value end,
				values = AceGUIWidgetLSMlists.sound,
				order = 1,
			},
			debugTxt = {
				type = "toggle",
				name = "DEBUG",
				desc = "DEBUG",
				get  = function() return addon.db.profile.debug end,
				set  = function() addon.db.profile.debug = not addon.db.profile.debug end,
				order = 2
			},
		},
	}
	return options
end

function addon:OnInitialize()

	local AceConfigDialog = LibStub("AceConfigDialog-3.0")
	self.db = LibStub("AceDB-3.0"):New(AddonName.."DB", defaults)
	LibStub("AceConfig-3.0"):RegisterOptionsTable(AddonName, self:Options(), "fotdcmd")
	self:RegisterChatCommand("fotd", function() AceConfigDialog:Open(AddonName) end)
		
	self.optionsFrame = AceConfigDialog:AddToBlizOptions(AddonName, AddonName)
	self.db:RegisterDefaults(defaults)
	
end

function addon:OnEnable()

	media:Register("sound", "Fanfare1", [[Interface\Addons\FuryDestroyer\Sound\Fanfare.ogg]])
	media:Register("sound", "Fanfare2", [[Interface\Addons\FuryDestroyer\Sound\Fanfare2.ogg]])
	media:Register("sound", "Fanfare3", [[Interface\Addons\FuryDestroyer\Sound\Fanfare3.ogg]])
	
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
		
end

local function Debug(...)
	if addon.db.profile.debug then
		local text = ""
		for i = 1, select("#", ...) do
			text = text..(select(i, ...) or "nil").." "
		end
		DEFAULT_CHAT_FRAME:AddMessage(TITLE..": "..text)
	end
end	

function addon:Debug(msg)

	if msg then
		addon.db.profile.debug = true
		Debug("Debug ON")
	else
		Debug("Debug OFF")
		addon.db.profile.debug = false
	end
	
end

function addon:PLAYER_ENTERING_WORLD(event,...)
	
	Debug(event,...)
	
	self:UnregisterEvent("PLAYER_ENTERING_WORLD");
	
	_, PlayerClass = UnitClass("player")
	Debug("Deine Classe: ",PlayerClass)
	if PlayerClass == "ROGUE" then
		Debug(GetSpellInfo(FDID))
		BuffName, _, BuffTex = GetSpellInfo(FDID)
		Debug(BuffName, BuffTex)
		
		self:RegisterEvent("UNIT_AURA")
	end
	
end

local play = false
function addon:UNIT_AURA(event,Unit)
	Debug(event,Unit)
	if UnitName(Unit) == UnitName("player") then
		local name, rank, buff, count, _, maxDuration, endTime = UnitBuff(Unit, BuffName, nil, "PLAYER")
		Debug(name,endTime)
		if (name and endTime > 0 ) then
			if play == false then
				PlaySoundFile(media:Fetch("sound", self.db.profile.SoundFile),"Master")
				play = true
			end
		else
			play = false
		end
	end
	
end

